close all

% generate a noisy, random dataset to fit
xAxis = linspace( -5, 5, 500 );
gaussianParameters = abs( randn( 1, 4) )
noisyData = Gaussian( gaussianParameters, xAxis ) + 0.05 * gaussianParameters(3) * randn( size( xAxis ) ); 

initialGuess = [ 1 1 range( noisyData ) min( noisyData ) ];

figure;
plot( xAxis, noisyData, 'o' );
hold on
plot( xAxis, Gaussian( gaussianParameters, xAxis ), 'y' );
plot( xAxis, Gaussian( initialGuess, xAxis ), 'r' );
 
[bestFit,residual,j,COVB,mse] = ...
	nlinfit(xAxis, noisyData, @Gaussian, initialGuess);

confidenceInterval = nlparci(bestFit, residual, 'covar', COVB);

plot(xAxis, Gaussian(bestFit, xAxis),'g');
title('Noisy Gaussian and Best Fit', 'FontSize', 16);
legend( 'Noisy Data', 'Underlying', 'Initial Guess', 'Best Fit' );
